﻿Imports System.Windows.Forms

Public Class PluginInterface

    Public Interface SFDLLoaderPlugin

        Sub Load()

        Function GetName() As String
        Function GetVersion() As String
        Function GetAuthor() As String
        Function GetPlatfomCompatibility() As Platform
        Function SpecialPluginFunctions() As List(Of SpeicalPluginFunction)

        Function HasSettings() As Boolean
        Function GetSettingsTab() As UserControl
        Function GetSettingsTabName() As String
        Sub SaveSettings()

        Function GetCommandButtonName() As String
        Sub CommandButtonEvent(sender As Object, e As EventArgs)

        Function ClicknLoadSupportedHosts() As List(Of String)
        Function ClicknLoadURLSupported(ByVal _url As String) As Boolean
        Function ClicknLoadDownloadSFDL(ByVal _url As String) As String

        Sub PostSessionDownload(ByVal _session As Object, ByVal _has_downloaded_files As Boolean)
        Sub PostItemDownload(ByVal _item As Object, _session_uid As String, _event_type As Object)

    End Interface

    Public Enum Platform
        Windows
        Linux
        Multi
    End Enum


    Public Enum SpeicalPluginFunction
        ClicknLoad
        CommandButton
        PostSessionDownload
        PostItemDownload
    End Enum

End Class
