﻿Imports System.Text
Imports System.ComponentModel.Composition
Imports System.ComponentModel.Composition.Hosting

Public Class PluginConnector
    <ImportMany(GetType(SFDL.PluginInterface.PluginInterface.SFDLLoaderPlugin))> _
    Public Plugins As SFDL.PluginInterface.PluginInterface.SFDLLoaderPlugin()

    Dim _tools As New Tools
    Dim _logger As New Logger
    Dim catalog As DirectoryCatalog
    Dim container As CompositionContainer

    'Public Event SFDLLoaderPluginsLoaded(ByVal _plugins As List(Of PluginInterface.PluginInterface.SFDLLoaderPlugin))
    'Public Event UnfilteredSFDLLoaderPluginsLoaded(ByVal _plugins As List(Of PluginInterface.PluginInterface.SFDLLoaderPlugin))

    'Private Function LoadSFDLLoaderPlugin(ByVal _plugin_file As String) As PluginInterface.PluginInterface.SFDLLoaderPlugin

    '    Dim vPlugIn As PluginInterface.PluginInterface.SFDLLoaderPlugin
    '    Dim a As System.Reflection.Assembly = System.Reflection.Assembly.LoadFile(_plugin_file)

    '    Try

    '        Dim types() As Type = a.GetTypes

    '        For Each pType As Type In types
    '            'hier wird versucht die dll zu laden.
    '            'dies funktioniert nur, wenn die dll auch das selbe interface implementiert
    '            'wie der host vorgiebt
    '            Try

    '                vPlugIn = CType(a.CreateInstance(pType.FullName), PluginInterface.PluginInterface.SFDLLoaderPlugin)
    '                'dll ist ein gültiges plugin

    '                Return vPlugIn

    '            Catch ex As Exception

    '            End Try

    '        Next
    '        'keine gültige dll gefunden
    '        Return Nothing

    '    Catch ex As Exception
    '        _logger.WriteLog("Plugin Connector - LoadPlugin", "Fehler beim laden des Plugins " & _plugin_file.ToString, LogType.Fehler)
    '    End Try

    '    Return Nothing


    'End Function

#Region "Plugin System Funktionen"

    Public Sub LoadPlugins(ByVal _plugindir As String)

        catalog = New DirectoryCatalog(_plugindir, "*.dll")
        container = New CompositionContainer(catalog) 'Quelle zum Container hinzufügen
        container.ComposeParts(Me)

    End Sub

    Public Sub DisablePlugin(ByVal _pluginindex As Integer)

        Dim _file_name As String

        _file_name = catalog.LoadedFiles(_pluginindex)

        If IO.File.Exists(_file_name) Then
            IO.File.Move(_file_name, _file_name & ".disabled")
        End If


    End Sub


    'Public Sub LoaderSFDLLoaderPlugins(ByVal _plugindir As String, Optional ByVal _ignore_disable_file As Boolean = False)

    '    Dim _plugins As New List(Of PluginInterface.PluginInterface.SFDLLoaderPlugin)
    '    Dim _dis_file As String = String.Empty


    '    For Each _plugin As String In IO.Directory.GetFiles(_plugindir, "*.dll")

    '        Dim _myplugin_info As New StringBuilder
    '        Dim _myplugin As PluginInterface.PluginInterface.SFDLLoaderPlugin

    '        Try

    '            _myplugin = LoadSFDLLoaderPlugin(_plugin)


    '            _dis_file = IO.Path.Combine(_plugindir, _myplugin.GetName & ".dis")

    '            If IO.File.Exists(_dis_file) And _ignore_disable_file = False Then
    '                Throw New Exception("Plugin ist deaktiviert!")
    '            End If

    '            _myplugin_info.AppendLine("")
    '            _myplugin_info.AppendLine("-----------------------------")
    '            _myplugin_info.AppendLine("Name: " & _myplugin.GetName)
    '            _myplugin_info.AppendLine("Version: " & _myplugin.GetVersion)
    '            _myplugin_info.AppendLine("Author: " & _myplugin.GetAuthor)
    '            _myplugin_info.AppendLine("-----------------------------")

    '            _logger.WriteLog("Plugin Connector - LoadPlugins", "Lade Plugin: " & _myplugin_info.ToString)


    '            If _tools.IsLinux() = True And _myplugin.GetPlatfomCompatibility = PluginInterface.PluginInterface.Platform.Windows Then
    '                Throw New Exception("Das Plugin '" & _myplugin.GetName & "' ist nicht kompatibel mit diesem Betriebsystem!")
    '            End If

    '            If _tools.IsLinux() = False And _myplugin.GetPlatfomCompatibility = PluginInterface.PluginInterface.Platform.Linux Then
    '                Throw New Exception("Das Plugin '" & _myplugin.GetName & "' ist nicht kompatibel mit diesem Betriebsystem!")
    '            End If

    '            _plugins.Add(_myplugin)

    '            _myplugin.Load()


    '        Catch ex As Exception
    '            _logger.WriteLog("Plugin Connector - LoadPlugins", "Plugin konnte nicht geladen werden!", LogType.Fehler)
    '        End Try

    '    Next

    '    If _ignore_disable_file = False Then
    '        RaiseEvent SFDLLoaderPluginsLoaded(_plugins)
    '    Else
    '        RaiseEvent UnfilteredSFDLLoaderPluginsLoaded(_plugins)
    '    End If

    'End Sub

#End Region


End Class
