﻿Imports System.Text
Imports System.Net.Sockets
Imports System.Net

Public Class WhoisResolver

    Dim _country_code As String = ""


    ''' <summary>
    ''' Funktion zum umsetzten der IP-Addresse in einen Ländercode
    ''' </summary>
    Public Function Resolve(ByVal _ip As String) As String

        Dim _logger As New Logger

        Try

            Dim XMLReader As New Xml.XmlDocument
            Dim xmlKD As Xml.XmlElement

            _logger.WriteLog("WhoIs", String.Format("Ermittle WohIs für IP {0}", _ip))

            _country_code = ""

            XMLReader.Load("http://xml.utrace.de/?query=" & _ip)

            xmlKD = CType(XMLReader.DocumentElement.ChildNodes(0), Xml.XmlElement)

            For Each _node As Xml.XmlNode In xmlKD.ChildNodes

                If _node.Name = "countrycode" Then

                    _country_code = _node.ChildNodes(0).Value

                End If

            Next

            _logger.WriteLog("WhoIs", String.Format("Ermittle ermittelter CounterCode: {0}", _country_code))

            Return _country_code

        Catch ex As Exception

            _logger.WriteLog("WhoIs", ex.Message, LogType.Fehler)

            Return "False"

        End Try

    End Function

End Class