﻿Public Class frm_log

    Dim _logger As New SFDL.Core.Logger

    Private Sub frm_log_FormClosing(sender As Object, e As Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        RemoveHandler _logger.LogChanged, AddressOf LogChangedEvent
    End Sub

    Private Sub frm_log_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim _frm_main As New SFDL.Loader.frm_main

        _logger = _frm_main.GetLoggerInstance

        AddHandler _logger.LogChanged, AddressOf LogChangedEvent

        GetLog()

    End Sub

    Private Sub LogChangedEvent(_log_text As String)
        GetLog()
    End Sub

    Private Sub GetLog()

        If Me.InvokeRequired Then
            Me.Invoke(Sub() Me.GetLog())
        Else
            rtb_log.Clear()
            rtb_log.Text = _logger.GetLog

            'Ans Ende Scrollen
            rtb_log.SelectionStart = rtb_log.Text.Length
            rtb_log.ScrollToCaret()

        End If

    End Sub

    Private Sub ClearLog()

        If Me.InvokeRequired Then
            Me.Invoke(Sub() Me.ClearLog())
        Else
            rtb_log.Clear()
        End If

    End Sub

    Private Sub RefreshToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles RefreshToolStripMenuItem.Click
        GetLog()
    End Sub

    Private Sub LogLeerenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles LogLeerenToolStripMenuItem.Click
        ClearLog()
    End Sub
End Class