﻿Public Class frm_opensfdl_encrypted

    Private _password As String
    Private _test_decrypt_string As String

    Protected Friend ReadOnly Property GetPassword As String
        Get
            Return _password
        End Get
    End Property

    Protected Friend WriteOnly Property SetTestDecryptString As String
        Set(value As String)
            _test_decrypt_string = value
        End Set
    End Property


    Private Sub OK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK.Click

        Dim _crypto As New SFDL.Crypto.AES
        Dim _tmp As String

        _password = PasswordTextBox.Text

        Try

            _tmp = _crypto.DecryptString(_test_decrypt_string, _password)

            Me.DialogResult = Windows.Forms.DialogResult.OK
            Me.Close()

        Catch ex As Crypto.FalsePasswordException


            ToolTipPassword.IsBalloon = True
            ToolTipPassword.UseAnimation = True
            ToolTipPassword.UseFading = True
            ToolTipPassword.SetToolTip(PasswordTextBox, "Du hast ein falsches Kennwort eingeben!")
            ToolTipPassword.ToolTipTitle = "Falsches Passwort"
            ToolTipPassword.ToolTipIcon = ToolTipIcon.Error

            ToolTipPassword.Active = True
            ToolTipPassword.Show("Du hast ein falsches Kennwort eingeben!", PasswordTextBox)

            PasswordTextBox.Clear()

        End Try

    End Sub

    Private Sub Cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel.Click
        Me.DialogResult = Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub LoginForm1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

    End Sub

    Private Sub PasswordTextBox_KeyDown(sender As Object, e As KeyEventArgs) Handles PasswordTextBox.KeyDown
        If e.KeyCode = Keys.Return Or e.KeyCode = Keys.Enter Then
            OK.PerformClick()
        End If
    End Sub
End Class
