﻿Option Strict On

Imports System.ComponentModel

Namespace FTP
    ''' <summary>
    ''' Provides data for the GetFileAsyncCompleted event.
    ''' </summary>
    Public Class GetFileAsyncCompletedEventArgs
        Inherits AsyncCompletedEventArgs
        ''' <summary>
        '''  Initializes a new instance of the GetFileAsyncCompletedEventArgs class.
        ''' </summary>
        ''' <param name="error">Any error that occurred during the asynchronous operation.</param>
        ''' <param name="canceled">A value indicating whether the asynchronous operation was canceled.</param>
        Public Sub New(ByVal [error] As Exception, ByVal canceled As Boolean)
            MyBase.New([error], canceled, Nothing)
        End Sub
    End Class

End Namespace