﻿Public Class FileInfo

    Private FileName As String
    Private DirectoryRoot As String
    Private DirectoryPath As String
    Private FileFullPath As String
    Private FileSize As Long
    Private MD5FileHash As String
    ''' <summary>
    ''' Gibt den Dateinamen der Datei an.
    ''' </summary>

    Public Property GetSetFileName As String
        Set(value As String)
            FileName = value
        End Set
        Get
            Return FileName
        End Get
    End Property
    ''' <summary>
    ''' Gibt den Root Pfad der Datei an.
    ''' z.B REALESE.AC3-inD\CD1
    ''' </summary>
    Public Property GetSetDirectoryRoot As String
        Set(value As String)
            DirectoryRoot = value
        End Set
        Get
            Return DirectoryRoot
        End Get
    End Property
    ''' <summary>
    ''' Gibt den Ordner an im welchem die Datei liegt.
    ''' </summary>
    Public Property GetSetDirectoryPath As String
        Set(value As String)
            DirectoryPath = value
        End Set
        Get
            Return DirectoryPath
        End Get
    End Property
    ''' <summary>
    ''' Gibt den vollen Pfad der Datei zurück.
    ''' </summary>
    Public Property GetSetFileFullPath As String
        Set(value As String)
            FileFullPath = value
        End Set
        Get
            Return FileFullPath
        End Get
    End Property
    ''' <summary>
    ''' Gibt die Dateigröße in Bytes zurück.
    ''' </summary>
    Public Property GetSetFileSize As Long
        Set(value As Long)
            FileSize = value
        End Set
        Get
            Return FileSize
        End Get
    End Property
    ''' <summary>
    ''' Gibt den MD5-Hash der Datei zurück.
    ''' </summary>
    ''' <remarks>Der Wert ist Optional und kann leer sein!</remarks>
    Public Property GetSetMD5FileHash As String
        Set(value As String)
            MD5FileHash = value
        End Set
        Get
            Return MD5FileHash
        End Get
    End Property


End Class
