﻿Imports System.Text

Public Class Logger

    Private Shared _var_log As New StringBuilder
    Public Event LogChanged(ByVal _log_text As String)

    Public ReadOnly Property GetLog As String
        Get
            Return _var_log.ToString
        End Get
    End Property

    Public Sub WriteLog(ByVal _source As String, ByVal _log_str As String, Optional ByVal _log_type As LogType = LogType.Info)

        Select Case _log_type

            Case LogType.Info

                _var_log.AppendLine(String.Format("[INFO] [{0}] {1}", _source, _log_str))

#If DEBUG Then
                Debug.WriteLine(String.Format("[INFO] [{0}] {1}", _source, _log_str))
#End If

            Case LogType.Fehler

                _var_log.AppendLine(String.Format("[FEHLER] [{0}] {1}", _source, _log_str))

#If DEBUG Then
                Debug.WriteLine(String.Format("[FEHLER] [{0}] {1}", _source, _log_str))
#End If

            Case LogType.Warnung

                _var_log.AppendLine(String.Format("[WARNUNG] [{0}] {1}", _source, _log_str))


#If DEBUG Then
                Debug.WriteLine(String.Format("[WARNUNG] [{0}] {1}", _source, _log_str))
#End If

        End Select

        RaiseEvent LogChanged(_var_log.ToString)

    End Sub

End Class

Public Enum LogType
    Info
    Fehler
    Warnung
End Enum