﻿Option Strict On

Namespace FTP
    ''' <summary>
    ''' Enumeration representing type of file transfer mode.
    ''' </summary>
    Public Enum TransferType As Integer
        ''' <summary>
        ''' No transfer type.
        ''' </summary>
        None
        ''' <summary>
        ''' Transfer mode of type 'A' (ascii).
        ''' </summary>
        Ascii
        ''' <summary>
        ''' Transfer mode of type 'I' (image or binary)
        ''' </summary>
        Binary
    End Enum
End Namespace